package com.emato.cuspay.wx.service.impl;


import com.emato.cuspay.common.contant.TablePrimaryKeyPrefix;
import com.emato.cuspay.common.core.db.IdWorkerAide;
import com.emato.cuspay.dao.mapper.merch.MerchPayCfgMapper;
import com.emato.cuspay.dao.mapper.wx.WxCbPayDocMapper;
import com.emato.cuspay.wx.dao.entity.WxCbPayDoc;
import com.emato.cuspay.support.msg.resp.ResponseMessage;
import com.emato.cuspay.support.msg.resp.ResponseStatus;
import com.emato.cuspay.util.jackson.JacksonUtil;
import com.emato.cuspay.wx.common.WxDict;
import com.emato.cuspay.wx.service.WxCbPayDocService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

/**
 * @author huangyq
 * @version 1.0
 * 2018-05-18 16:05
 */
@Service
public class WxCbPayDocServiceImpl implements WxCbPayDocService {
    @Autowired
    private WxCbPayDocMapper wxCbPayDocMapper;

    @Autowired
    private MerchPayCfgMapper merchPayCfgMapper;

    /**
     * 支付单信息入库
     * @param wxCbPayDoc 微信支付单证
     * @return
     */
    public ResponseMessage addWxCbPayDoc(WxCbPayDoc wxCbPayDoc) {
        wxCbPayDoc.setWxPaySn(TablePrimaryKeyPrefix.wx_cb_pay_type + IdWorkerAide.nextId());
        //设置支付单状态 待审核
        wxCbPayDoc.setDocStatus(WxDict.PaymentDocStatus.i_00.getItem());
        String merchSn = wxCbPayDoc.getMerchSn();

        if(merchPayCfgMapper.selectByWxMercherSn(merchSn) == null){
            return  new ResponseMessage.Builder().setCode(ResponseStatus.ERROR.getItem()).setMsg("商户编号为"+merchSn+"的支付配置信息不存在")
                    .build();
        }

        int result = wxCbPayDocMapper.insertSelective(wxCbPayDoc);
        if (result > 0) {
            HashMap<String,String> resultMap = new HashMap<>();
            resultMap.put("docStatus", WxDict.PaymentDocStatus.i_00.getItemName());

            return new ResponseMessage.Builder().setCode(ResponseStatus.SUCCESS.getItem()).setMsg("入库成功")
                    .setData(JacksonUtil.toJson(resultMap)).build();
        }
        return  new ResponseMessage.Builder().setCode(ResponseStatus.ERROR.getItem()).setMsg("入库失败")
                .build();
    }

    public List<WxCbPayDoc> selectBeDeclaredData(Integer limit) {
        return wxCbPayDocMapper.selectBeDeclaredData(limit);
    }

    public int updateWxCbPay(WxCbPayDoc wxCbPayDoc) {
        return wxCbPayDocMapper.updateByPrimaryKeySelective(wxCbPayDoc);
    }

    public int updateBatch(List<WxCbPayDoc> wxCbPayDocs) {
        return  wxCbPayDocMapper.updateBatch(wxCbPayDocs);
    }
}
